<?php

/* ######################################################################

  IML DEPLOYMENT

  webgui - html tester

  ---------------------------------------------------------------------
  ...
  2024-09-03  Axel <axel.hahn@unibe.ch>  php8 only; added variable types; short array syntax
  ###################################################################### */

require_once("./classes/project.class.php");


/**
 * helper: get html code for a table row
 * @global htmlguielements $oHtml
 * @param string   $sDescr  description
 * @param string   $sCode   php code
 * @return string
 */
function addHtmltestTest(string $sDescr, string $sCode): string
{
    $oHtml = new htmlguielements();
    $sOut = '??';
    eval ("\$sOut=$sCode;");

    return '<tr>'
        . '<td>'
        . $sDescr
        . '</td>'
        . '<td style="padding: 0 1em;"><pre>'
        . htmlentities($sCode)
        . '</pre></td>'
        . '<td style="padding: 0 1em;">'
        . $sOut
        . '</td>'
        . '<td style="padding: 0 1em;"><pre>'
        . str_replace('&gt;', '&gt;<br>', htmlentities($sOut))
        . '</pre></td>'
        . '</tr>';
}


// ----------------------------------------------------------------------
// MAIN
// ----------------------------------------------------------------------
$oHtml = new htmlguielements();

// generate a List of al icons
$sIconlist = '';
$sIconlist .= '<strong>Buttons</strong><br>';

        

foreach ($oHtml->aCfg['buttons'] as $sLabel => $aItems) {
    $sIconlist .= $oHtml->getIcon((string)$aItems['icon']) . ' - ' . $sLabel . ' - ' . $aItems['icon'] . '<br>';
}
$sIconlist .= '<br><strong>Icons</strong><br>';
foreach ($oHtml->aCfg['icons'] as $sLabel => $sIcon) {
    $sIconlist .= $oHtml->getIcon($sIcon) . ' - ' . $sLabel . ': ' . $sIcon . '<br>';
}

$sRows = ''
    . addHtmltestTest("Box zeichnen - Fehler", "\$oHtml->getBox('error', 'errormessage')")
    . addHtmltestTest("Box zeichnen - Warnung", "\$oHtml->getBox('warning', 'Message')")
    . addHtmltestTest("Box zeichnen - Info", "\$oHtml->getBox('info', 'Message')")
    . addHtmltestTest("Box zeichnen - OK", "\$oHtml->getBox('success', 'Message')")

    . addHtmltestTest("Icon - Fontawesome", "\$oHtml->getIcon('fa-close');")

    . '<tr>'
    . '<td>pre-defined icons</td>'
    . '<td>-</td>'
    . '<td>' . $sIconlist . '</td>'
    . '<td>-</td>'
    . '</tr>'

    . addHtmltestTest("Link", "\$oHtml->getLink([
    'href'=>'https://www.axel-hahn.de/',
    'icon'=>'fa-globe',
    'label'=>'Axels Webseite',
]);")
    . addHtmltestTest("Link als Button", "\$oHtml->getLinkButton([
    'href'=>'https://www.axel-hahn.de/',
    'target'=>'_blank',
    'icon'=>'fa-globe',
    'label'=>'Axels Webseite',
]);")
    . addHtmltestTest("Link als Button mit Type OK", "\$oHtml->getLinkButton(['type'=>'ok',]);")
    . addHtmltestTest("Link als Button mit Type close", "\$oHtml->getLinkButton(['type'=>'close',]);")
    . addHtmltestTest("Link als Button mit Type error", "\$oHtml->getLinkButton(['type'=>'error','label'=>'Fehler']);")

    //    . addHtmltestTest("Tabs", "\$oHtml->getNav(
//     [
//         'options' => [
//             'type'=>'tabs',
//             'justified'=>1,
//         ],
//         'tabs' => [
//             'tab 1'=>'Inhalt #1',
//             'tab 2'=>'Inhalt #2',
//         ],
//     ]
// );")
//    . addHtmltestTest("Tabs", "\$oHtml->getNav(
//     [
//         'options' => [
//             'type'=>'pills',
//             'stacked'=>1,
//         ],
//         'tabs' => [
//             'tab 1'=>'Inhalt #1',
//             'tab 2'=>'Inhalt #2',
//         ],
//     ]
// );")
    . addHtmltestTest(
        "Tabelle",
        "\$oHtml->getTable(
    [
        'header'=>['A', 'B'], 
        'body'=>[
            ['Zelle A 1', 'Zelle B 1'],
            ['Zelle A 2', 'Zelle B 2'],
            ['Zelle A 3', 'Zelle B 3'],
        ],
    ]);"
    )
;

// ----------------------------------------------------------------------

echo '<table><thead>'
    . '<tr>'
    . '<th>Beschreibung</th>'
    . '<th>PHP-Code</th>'
    . '<th>Ausgabe</th>'
    . '<th>Ausgabe-Code</th>'
    . '</tr>'
    . '</thead><tbody>'
    . $sRows
    . '</tbody></table>'
;
